menu = {}
menu.current = 1
love.keyboard.setKeyRepeat(.25, .0075)	
menu.states = {main = {}, options = {}}
	menu.states.main.list = {text = {}, functions = {}, values = {}}
		menu.states.main.list.text[1] = 'Play'
		menu.states.main.list.text[2] = 'Options'
		menu.states.main.list.text[3] = 'Quit'
		menu.states.main.list.functions[1] = function() state = game; game.load() end
		menu.states.main.list.functions[2] = function() menu.state = menu.states.options end
		menu.states.main.list.functions[3] = function() love.event.push 'quit' end
		menu.states.main.list.values = {'', '', ''}
		
	menu.states.options.list = {text = {}, functions = {}, values = {}}
		menu.states.options.list.text[1] = 'Speed'
		menu.states.options.list.text[2] = 'Snake1 - R'
		menu.states.options.list.text[3] = 'Snake1 - G'
		menu.states.options.list.text[4] = 'Snake1 - B'
		menu.states.options.list.text[5] = 'Snake2 - R'
		menu.states.options.list.text[6] = 'Snake2 - G'
		menu.states.options.list.text[7] = 'Snake2 - B'
		menu.states.options.list.text[8] = 'Face'
		menu.states.options.list.text[9] = 'Back'
		menu.states.options.list.functions[1] = function(key) if key == 'left' then menu.state.list.values[1] = math.max(menu.state.list.values[1] - 1, 7) elseif key == 'right' then menu.state.list.values[1] = math.min(menu.state.list.values[1]+1, 120) end end
		menu.states.options.list.functions[2] = function(key) if key == 'left' then menu.state.list.values[2] = math.max(menu.state.list.values[2] - 1, 0) elseif key == 'right' then menu.state.list.values[2] = math.min(menu.state.list.values[2]+1, 255) end end
		menu.states.options.list.functions[3] = function(key) if key == 'left' then menu.state.list.values[3] = math.max(menu.state.list.values[3] - 1, 0) elseif key == 'right' then menu.state.list.values[3] = math.min(menu.state.list.values[3]+1, 255) end end
		menu.states.options.list.functions[4] = function(key) if key == 'left' then menu.state.list.values[4] = math.max(menu.state.list.values[4] - 1, 0) elseif key == 'right' then menu.state.list.values[4] = math.min(menu.state.list.values[4]+1, 255) end end
		menu.states.options.list.functions[5] = function(key) if key == 'left' then menu.state.list.values[5] = math.max(menu.state.list.values[5] - 1, 0) elseif key == 'right' then menu.state.list.values[5] = math.min(menu.state.list.values[5]+1, 255) end end
		menu.states.options.list.functions[6] = function(key) if key == 'left' then menu.state.list.values[6] = math.max(menu.state.list.values[6] - 1, 0) elseif key == 'right' then menu.state.list.values[6] = math.min(menu.state.list.values[6]+1, 255) end end
		menu.states.options.list.functions[7] = function(key) if key == 'left' then menu.state.list.values[7] = math.max(menu.state.list.values[7] - 1, 0) elseif key == 'right' then menu.state.list.values[7] = math.min(menu.state.list.values[7]+1, 255) end end
		menu.states.options.list.functions[8] = function(key) if key == 'enter' or key == 'return' then menu.states.options.list.values[8] = not menu.states.options.list.values[8] end end
		menu.states.options.list.functions[9] = function(key) if key == 'enter' or key == 'return' then menu.current = 1; menu.state = menu.states.main end end
		menu.states.options.list.values = {20, 0, 192, 0, 0, 0, 192, false, ''}

menu.state = menu.states.main
	
menu.load = function()
	
end

menu.update = function(dt)

end

menu.draw = function()
	for i, v in ipairs(menu.state.list.text) do
		if menu.state == menu.states.options then
			v = v .. ': ' .. tostring(menu.state.list.values[i])
		end
		love.graphics.printf(v, 0, 200+i*24, 800, 'center')
	end
	love.graphics.setColor(255,0,0)
		if menu.state == menu.states.options then
			txt = menu.state.list.text[menu.current] .. ': ' .. tostring(menu.state.list.values[menu.current])
		else
			txt = menu.state.list.text[menu.current]
		end
		love.graphics.printf(txt, 0, 200+menu.current*24, 800, 'center')
	love.graphics.setColor(255,255,255)
end

menu.keypressed = function(key, unicode)
	if key == 'up' then
		menu.current = menu.current - 1
		if menu.current > #menu.state.list.text then menu.current = 1
		elseif menu.current <= 0 then menu.current = #menu.state.list.text end
	elseif key == 'down' then
		menu.current = menu.current + 1
		if menu.current > #menu.state.list.text then menu.current = 1
		elseif menu.current <= 0 then menu.current = #menu.state.list.text end
	end
	if menu.state == menu.states.main then
		if key == 'enter' or key == 'return' then
			menu.state.list.functions[menu.current]()
		end
	elseif menu.state == menu.states.options then
		menu.state.list.functions[menu.current](key)
	end
end